<!DOCTYPE html>
<html lang="en">
<head>
  <title>Email manager</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="../assets/css/bootstrap.min.css">

  <script src="https://cdn.ckeditor.com/4.11.1/standard/ckeditor.js"></script>

  <script src="../assets/js/jquery.min.js"></script>
  <script src="../assets/js/bootstrap.min.js"></script>

  <script type="text/javascript" src="../assets/js/resize-win.js"></script>

  <link rel="stylesheet" href="../assets/css/w3.css">
 
<style>
    #drag1:hover {
        cursor: pointer;
    }

    #div1 {
        float: left;
        width: 100px;
        height: 100px;
        margin: 10px;
        padding: 0px;
        border: 1px solid green;
    }


    #div2 {
        width: 100%;
        height: 1200px;
        border: 1px solid blue;
    }

    table, th, td {
        border: 1px solid lightblue;
        border-collapse: collapse;
    }

    td {
        height: 20px;

        /* cells resizable */
        overflow: auto;
        resize: both;
    }

    body {
      /*background-color: #262626;*/
    }

    #div2 {
      background-color:  #bfd999; /* #ccffff; */
    } 

    h2, p {
      color: black;
      font-family: sans-serif;
      /*text-align: center;*/
    }

    /*
        #div1 {
          text-align: center;
        }
    */

    .em {
        display: none;
    }

    #email-title {
        color: blue;
    }

    /*        
        input[type='text'], input[type='email'], textarea {
            border: 1px solid black;
        }

        input[type='text']:focus, input[type='email']:focus, textarea: focus {
            border: 1px solid blue;
        }   
    */     

    .form-control {
        border: 1px solid blue;
        height: 25px; /* 40px */
        font-size: 15px; /* 20px */
        padding-top: 5px 5px; /* 10 => 5 + 5 => (tb, lr) */
        border-radius: 0px;
    }

    .form-control:focus {
        border: 1px solid black;
    }

    label {
        font-family: sans-serif;
        font-weight: bold;
    }

    .attachments-svg {
        width: 50px;
        height: 50px;
        cursor: pointer;
    }

    .attachments-svg:hover {
        background-color: #bfd990;
    }
</style>

<style>
    .card {
        box-shadow: 0 4px 8px 0 rgba(0,0,0,0.2);
        transition: 0.3s;
        width: 100%;
    }

    .card:hover {
        box-shadow: 0 8px 16px 0 rgba(0,0,0,0.2);
    }

    .container2 {
        padding: 2px 16px;
    }

    .container2 h5, .container2 p {
        color: gray;
    }

    .container2 h5 b {
        font-family: serif;
    }
</style>

<style type="text/css">
    #email-desc {
        font-size: 12px;
        margin-top: 0px;
        font-family: sans-serif;
    }
</style>

<script type="text/javascript" src="../app/em.js"></script>
</head>

<body>
<!-- <body onload="resizeThisPageTo(800, 700)"> -->
<!-- TABS -->
<div class="w3-bar w3-black">
    <!--   
        <button class="w3-bar-item w3-button" onclick="openCity('London')">File</button>
        <button class="w3-bar-item w3-button" onclick="openCity('Paris')">Edit</button>
        <button class="w3-bar-item w3-button" onclick="openCity('Tokyo')">View</button>
        <button class="w3-bar-item w3-button" onclick="openCity('Tokyo')">Typeset</button>
        <button class="w3-bar-item w3-button" onclick="openCity('Tokyo')">Find</button>
        <button class="w3-bar-item w3-button" onclick="openCity('Tokyo')">Settings</button>
        <button class="w3-bar-item w3-button" onclick="openCity('Tokyo')">Help</button> 
    -->

    <button class="w3-bar-item w3-button">File</button>
    <button class="w3-bar-item w3-button">Edit</button>
    <button class="w3-bar-item w3-button">View</button>
    <button class="w3-bar-item w3-button">Typeset</button>
    <button class="w3-bar-item w3-button">Find</button>
    <button class="w3-bar-item w3-button">Settings</button>
    <button class="w3-bar-item w3-button">Help</button>
</div>
<!-- TABS CLOSED -->
    <div class="container-fluid text-center">
        <div class="row">
            <div class="col-md-3 text-left">
                <h3>
                    <img src="../assets/images/svg/email2.svg" style="width: 20px">
                    All mails
                    <br><span id='email-desc'>By date (in decreasing order)</span>
                </h3>
                <hr>
                <div class="card">
                    <div class="container2">
                        <h5>
                            <b>Great libraries - Python</b>
                        </h5> 
                        <p>Online course for be..., 
                            <span style="color:gray; float: right;">24 Feb 2018</span>
                        </p>
                    </div>
                </div>
                <div class="card">
                    <div class="container2">
                        <h5>
                            <b>Python tutorial</b>
                        </h5> 
                        <p>Pandas, Numpy, Matplotlib, 
                            <span style="color:gray; float: right">22 Mar 2018</span>
                        </p> 
                    </div>
                </div>
                <div class="card">
                    <div class="container2">
                        <h5>
                            <b>Data science</b>
                        </h5> 
                        <p>Learn Data science ...,  
                            <span style="color:gray; float: right;">22 Dec 2018</span>
                        </p> 
                    </div>
                </div>

                <hr>
                <button class="btn btn-success" onclick="startAutomaticFill()"> START</button>
            </div>

            <div class="col-md-9 text-center">
                <h2>&raquo; Send email, templates &laquo; 
                    <a href="index.html" style="color: blue">Go back</a>
                </h2>

                <p>+ Drag and drop the email icon to create the email task</p>

                <div id="div1">
                  <img src="../assets/images/svg/email.svg" draggable="true" ondragstart="drag(event)" id="drag1" width="100" height="100" alt="Draggble Image">
                </div>           
            </div>
        <!-- </div> -->

        <!-- <div class="row"> -->
            <div class="col-md-9 col-md-offset-3 text-left">
                
                <div id="div2" ondrop="drop(event)" ondragover="allowDrop(event)">
                    <div class="col-md-8 col-md-offset-2">
                        <h2 class="em" id='email-title'>Create email task</h2>
                        <hr>

                        <form onsubmit="sendMail(event)" class="em" name="email-form">
                            <div class="form-group">
                                <label for="from"><i class='fas fa-address-card'></i> FROM </label>
                                <input type="email" class="form-control" id="from">
                            </div>

                            <div class="form-group">
                                <label for="to"><i class="fas fa-users"></i> TO</label>
                                <input type="text" class="form-control" id="to">
                            </div>

                            <div class="form-group">
                                <label for="cc"><i class="fas fa-users"></i> CC</label>
                                <input type="text" class="form-control" id="cc" name="cc">
                            </div>

                            <div class="form-group">
                                <label for="bcc"><i class="fas fa-users"></i> BCC</label>
                                <input type="text" class="form-control" id="bcc" name="bcc">
                            </div>

                            <div class="form-group">
                                <label for="subject"><i class="fa fa-indent"></i>SUBJECT</label>

                                <input type="text" class="form-control" id="subject" name="subject">
                            </div>

                            <div class="form-group">
                                <label for="message"><i class="fa fa-file-text"></i> MESSAGE</label>
                                <textarea class="form-control" name="message" rows="10" id="message"></textarea>
                            </div>

                            <div class="checkbox">
                                <label>
                                    <input type="checkbox" onclick="showAttachmentsControls(this.id)" id='chkbox'> Attachments
                                </label>
                            </div>

                            <hr class="attachments">
                            <input type="file" name="attachments" id="attachments" style="display: none">
                            <img src="../assets/images/svg/gallery.svg" class="attachments attachments-svg" onclick="chooseFile('#attachments')">
                            <img src="../assets/images/svg/attachment.svg" class="attachments attachments-svg" onclick="chooseFile('#attachments')">
                            <img src="../assets/images/svg/document.svg" class="attachments attachments-svg" onclick="chooseFile('#attachments')">
                            <hr class="attachments">

                            <button type="submit" class="btn btn-success">
                                <img src="../assets/images/svg/send.svg" style="width: 100px; height: 40px">
                            </button>
                        </form>
                    </div>
                </div>
            </div> 
            <!-- Column end -->
        </div>
    </div>


    <script type="text/javascript">
        // files
        // const path = require("path");
        const fs = require('fs');

        function sendRealMail(from, to, cc, bcc, subject, text, files, templateId, ...args) {
            // SEND MAIL (AS WE HAVE SUCCESSFULLY COLLECTED DATA FROM FORM)
            alert("Really a great work");

            const nodemailer = require("nodemailer");
            const fs = require('fs');
            const {userMail, userPass} = require("../app/secrets");

            console.log("Credentials: ", userMail, userPass);

            alert("Creating transport");

            const transport = nodemailer.createTransport({
                service: "gmail",
                auth: {
                    user: userMail,
                    pass: userPass
                }
            });

            console.log("Transport: ", transport);
            /* -- For multiple receivers --

                {
                    ...
                    "to": "myfriend@yahoo.com, myotherfriend@yahoo.com",
                    ...
                }
            */

            /*
                -- For HTML mail --

                {
                    ...
                    "html": "<h1>Welcome</h1><p>That was easy!</p>",
                    ...
                }
            */

            /* cc, bcc, attachments */

            /*
                ["rishikesh@sjainventures.com", "admin@gmail.com"]
                "rishikesh@sjainventures.com,admin@gmail.com"
            */

            alert("mailOptions");

            const mailOptions = {
                from: userMail,
                to: to,
                cc: [],
                bcc: [],
                subject: subject,
                text: text,
                html: text,
                attachments: [
                    {
                        filename: 'Hacker.jpg',
                        path: 'H:\\RishikeshAgrawani\\Projects\\Images\\Hacker.jpg',
                        cid: 'abc-Doc-Project-1234'
                    },
                    {
                        filename: 'README.md',
                        path: 'H:\\RishikeshAgrawani\\Projects\\GenWork\\README.md',
                        cid: 'abcDocProject#12345'
                    },
                    {
                        filename: 'Great-text-do-respect-girls.txt',
                        path: 'H:\\RishikeshAgrawani\\Projects\\GenWork\\Great-text-do-respect-girls.txt',
                        cid: 'abcDocProject#123'
                    },
                    {
                        raw: 'Content-Type: text/plain\r\n' +
                        'Content-Disposition: attachment;\r\n' +
                        '\r\n' +
                        'JSA-Nodemailer!'
                    },
                ]
            };

            console.log("Email options", mailOptions);
            alert("Sending your real mail now");

            try {
                transport.sendMail(mailOptions, (error, info) => {
                    if(error) {
                        console.log("ERROR: ");
                        console.log(error);

                        // --mixed-context => require()
                        // window.location.href = "./error-mail.html"; // I predicted
                    } else {
                        console.log(Object.keys(info));
                        console.log("Email sent: ", info.response);

                        if(typeof(Storage) !== undefined) {
                            // localStorage.setItem('info', JSON.stringify(info));

                            console.log(`Browser supports localStorage`);
                        } else {
                            console.log(`Browser does not support localStorage`);
                        }

                        //  /* "Create/Update" JSON file */
                        // fs.writeFile('data.json', JSON.stringify(mailOptions, null, 4), (err) => {
                        //     console.log('Successful');

                        //     // --mixed-context => require()
                        //     // window.location.href = "./success-mail.html"; // I predicted
                        //     console.log('Success!!!')
                        // });

                        let d = new Date(); // Instantiation of data object
                        console.log(d); 

                        let date = d.getFullYear() + "-" + d.getMonth() + "-" + d.getDate(); 

                        // Creating date
                        let time = d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds(); // Creating time

                        console.log(`${date} ${time}`);
                        alert(`TIME: ${time}: ${date}, writing to JSON file`);

                        try {
                            alert('GRT')
                            /* "Create/Update" JSON file */
                            if(!fs.existsSync('data.json')) { // If file does not exist
                                console.log('File data.json does not exist');

                                let data = {
                                    [date]: {
                                        [time]: mailOptions
                                    }
                                };

                                // console.log('Writing to file');
                                alert('Writing to the file (go)');

                                /* Async starts */
                                // fs.writeFile('data.json', JSON.stringify(data, null, 4), (err) => {
                                //     if(err) {
                                //         // Success
                                //         alert(`Data successfully written to file`); 
                                //         console.log(`Successful`); 
                                //     } else {
                                //         // Error
                                //         alert(`ERROR: ${err}`); 
                                //         console.log(`ERROR ${err}`); 
                                //     }
                                    
                                //     // --mixed-context => require()
                                //     // window.location.href = "./success-mail.html"; // I predicted
                                // });
                                
                                /* Async ends */
                                try{
                                    alert('Entering to try...');
                                    fs.writeFileSync('data.json', JSON.stringify(data, null, 4));
                                } catch(error) {
                                    alert('Great: error');
                                }

                                alert(`Current working directory's path: ${process.cwd()}`);
                            } else { // else1 starts
                                // Read the JSON file (if exists)
                                alert(`File exists, reading`);

                                fs.readFile('data.json', (err, data) => {
                                    if(err) {
                                        console.log(`ERROR (READ): + ${err}`);
                                    } else {
                                        data = JSON.parse(data.toString());

                                        if(data[date]) { 
                                            // e.g. '2015-04-12' 
                                            data[date][time] = mailOptions;
                                        } else {
                                            data[date] = {
                                                [time]: mailOptions
                                            };
                                        }

                                        alert('Now writing it');

                                        // Updating the JSON with new email data added
                                        fs.writeFile('data.json', JSON.stringify(data, null, 4), (err) => {
                                            if(err) {
                                                alert(`ERROR (READ): ${err}`);
                                                console.log(`ERROR (WRITE): ${err}`);
                                            } else {
                                                alert("JSON, successfully");
                                                console.log(`JSON successfully updated`);
                                            }
                                        });
                                    }
                                });
                                // 
                            } 
                            // else1 ends
                        } catch(err) {
                            alert(`GPT ${err}`);
                        }
                    }
                });
            } catch (error) {
                alert('ERROR')
                console.log("ERROR:-", error);

                // location.href = "error_mail.html";
            }
        }

        function sendMail(event) {
            event.preventDefault();

            let from = document.forms["email-form"]["from"].value;
            let to = document.forms["email-form"]["to"].value;
            let subject = document.forms["email-form"]["subject"].value;
            // let text = document.forms["email-form"]["message"].value;

            alert('GREAT1')
            let text = document.getElementsByClassName("cke_editable");

            console.log('Length: ', text.length);            
            console.log("From: ", from);
            console.log("To: ", to);
            console.log("Subject: ", subject);
            console.log("Message: ", text);
            console.log('About to send (Okay)?');

            sendRealMail(from, to, subject, text);
        } // Function ends her

        function showAttachmentsControls(chkboxId) {
            let chkbox = document.getElementById(chkboxId);
            console.log(chkbox.checked);

            if(chkbox.checked) {
                console.log("Yes, it is checked");
            } else {
                console.log("It is unchecked");
            }
        }
    </script>

    <script type="text/javascript">
        function chooseFile(name) {
            const fs = require("fs");
            var chooser = document.querySelector(name);
            console.log(name);

            chooser.addEventListener("change", function(evt) {
                console.log(this.value);

                // document.getElementById('h1').innerHTML = 'Selected file <span style="color:green">' + this.value + "</span>";

                // const content = fs.readFileSync(this.value, {encoding: 'UTF-8'});
                // document.getElementById('h2').style.display = 'block';
                // document.getElementById('content').value = content;

                if(type(Storage) !== "undefined") {
                    localStorage.setItem('path-i-rishi-dev', this.value);
                };

            }, false);

            chooser.click();  
        }

        // chooseFile('#fileDialog');
    </script>

    <script>
        // CKEDITOR.replace('message');
    </script>

    <script type="text/javascript">
        function startAutomaticFill() {
            var values = [
                   ['from', 'rishikesh0014051992@gmail.com'],
                   ['to', 'rishikesh@sjainventures.com'],
                   ['cc', 'rishikesh0011115067@gmail.com'],
                   ['bcc', 'hira@sjainventures.com'],
                   ['subject', 'This is subject Kite'],
                   ['message', 'Hi,\n\tgreat experience with you guys']
            ];

            t = 1000; // start 
            f = 1000; // add by

            for(let i = 0; i < values.length; i++) {
                console.log('Doing the work');

                setTimeout(function() {
                    document.getElementById(values[i][0]).value = values[i][1];
                    console.log('Done ...');
                }, t += f);
            }

        }
    </script>
</body>
</html>
